package com.docus.soap.api;

import com.docus.soap.api.request.zsyy.GetLoginInfoRequest;
import com.docus.soap.api.request.zsyy.GetQRCodeBySysRequest;
import com.docus.soap.api.request.zsyy.GetQueryQRCodeRequest;
import com.docus.soap.api.response.zsyy.GetLoginInfoResponse;
import com.docus.soap.api.response.zsyy.GetQRCodeBySysResponse;
import com.docus.soap.api.response.zsyy.GetQueryQRCodeResponse;
import com.docus.soap.api.service.XMZSYYQRCodeAPIService;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.core.env.Environment;

import javax.inject.Inject;

public class ComplaintAPIServiceTest extends SpringTest {

    private final Logger logger = LoggerFactory.getLogger(ComplaintAPIServiceTest.class);

    @Inject
    private Environment env;

    @Inject
    private XMZSYYQRCodeAPIService complaintAPIService;


    @Test
    @Ignore
    public void getTableByIdDateTest() {
        GetQRCodeBySysRequest request = new GetQRCodeBySysRequest();
        request.setSys("JSScan");
        GetQRCodeBySysResponse result = complaintAPIService.getQRCodeBySys(request, getTableByIdDateSettings());
        Assert.assertNotNull("not null", result);
    }


    @Test
    @Ignore
    public void getQueryQRCode() {
        GetQueryQRCodeRequest request = new GetQueryQRCodeRequest();
        request.setQrCode("二维码状态查询字符串");
        GetQueryQRCodeResponse queryQRCode = complaintAPIService.getQueryQRCode(request, queryQRCodeUrlAndName());
        Assert.assertNotNull("not null", queryQRCode);
    }


    @Test
    public void getLoginInfo() {
        GetLoginInfoRequest request = new GetLoginInfoRequest();
        request.setSys("JSScan");
        request.setAccountType("IdCardNumber");
        request.setAccount("350301200008100057");
        request.setPassword("lin123456");
        GetLoginInfoResponse loginInfo = complaintAPIService.getLoginInfo(request, getLoginUserInfo());
        Assert.assertNotNull("not null", loginInfo);
    }



    private SoapAPISettings getTableByIdDateSettings() {
        SoapAPISettings soapAPISettings = new SoapAPISettings();
        soapAPISettings.setAction(env.getProperty("soap.complaint.api.action"));
        soapAPISettings.setUri(env.getProperty("soap.complaint.api.url"));
        return soapAPISettings;
    }


    private SoapAPISettings queryQRCodeUrlAndName() {
        SoapAPISettings soapAPISettings = new SoapAPISettings();
        soapAPISettings.setAction("SOF_QueryQRCode");
        soapAPISettings.setUri("http://101.132.67.155:8087/PKIQRCode/services/v1?wsdl");
        return soapAPISettings;
    }


    private SoapAPISettings getLoginUserInfo() {
        SoapAPISettings soapAPISettings = new SoapAPISettings();
        soapAPISettings.setAction("SOF_LoginWithAccountInfo");
        soapAPISettings.setUri("http://101.132.67.155:8087/pkis/services/v1?wsdl");
        return soapAPISettings;
    }
}
